'freebasic
' (C) Dmitriy Korabelnikov aka Deckard of Atomic Destruction 28 September 2019
'
#include "ijl.bi"
deflng a-z

CONST KNOWPASS1 = 1
CONST MESSAGELEFT2 = 2
CONST FRIENDNEAR3 = 3
CONST FRIENDWAIT4 = 4
CONST HAVEKEY5 = 5
CONST HAVECASE6 = 6
CONST MISSIONEND7 = 7

CONST MAXVERB = 13
CONST MAXROOM = 20
CONST MAXPWD = 6

declare sub jpginit()
declare function jpgload(jname$) as long

DECLARE FUNCTION RAND (X)
declare function ind(N$)
declare SUB Apage (N)
declare SUB LoadRus
declare SUB say2 (y,txt$)
declare sub xPRINT(txt$)
declare function xINKEY$
DECLARE SUB xINPUT (y,M$)
DECLARE SUB waitkey
declare sub xCLS
declare sub mousecheck

declare sub gameintro()
declare function showpic(n as long)
declare function showaction
declare sub darkscreen
declare sub addpic(N$)
declare sub helpgame()
declare sub help2
declare SUB helptrain
declare sub GameLooseSub
declare sub GameLooseSub2
declare sub GameWinSub

declare sub ainvalid
declare sub adebug
declare sub aquit
declare sub await
declare sub amove
declare sub domove
declare sub aread
declare sub asearch
declare sub ahelp
declare sub aleave
declare sub asay
declare sub afollow
declare sub aexamine
declare sub aopen
declare sub showclock(gametime)

declare sub winaniload
declare sub winaniplay
declare sub makeanim

' Intel Jpeg Library handle
dim shared ijlib as any ptr
declare sub swaprgb()
Dim shared jcprops As JPEG_CORE_PROPERTIES
dim shared fname as zstring*256
dim shared jpgout as ulong ptr,winbg1 as ulong ptr,winbg2 as ulong ptr
dim shared anim as ulong ptr,spt(4100) as ulong

' Russian Windows to DOS decoding table
DIM SHARED win2dos(255) as ubyte, a1 as string*1
dim shared grafbuf(10000) as ulong,grafbuf2(10000) as ulong

'spy game variables
DIM SHARED room$(MAXROOM),roompic$(MAXROOM), action$(MAXVERB+1),actionpict$
dim shared acti$(20),actpic$(20),actcnt(20),actmax, flags(7),y0
dim shared openpic$(100),OpenMax
' P - player position, NP - new player position
DIM SHARED P, NP, playerY, playerX, EnemyPlace, NumberMoves, EnemyNear
' CP - letter collect place
dim shared MessagePlace, KeyPlace, CP, NumberLock,MeetingTime
' Time variables DT - time of one move
DIM SHARED H, M, tim,tim0, DT, FH, CH
DIM SHARED B$, Password$, Phrase$, MeetingPlaceName$
DIM SHARED wtflag,GameWin,GameLoose,exep$,transpar,debugflag


WindowTitle "MicroSpy - Rendezvous"
screenres 640,480,32,4
width 80,30
exep$=exepath
if mid$(exep$,len(exep$),1)<>"\" then exep$=exep$ + "\"
'? exep$:sleep
loadrus
jpginit
winaniload
help2
gamestart:
RANDOMIZE timer
gameintro
showpic ind("ARCADE")
helpgame
waitkey
' global variables init
debugflag=0
P = 1: playerY = 0: playerX = 1: EnemyPlace = ind("HOTEL")
MeetingTime = 0: NumberMoves = 0: Verb = 0
MeetingPlaceName$ = ""
B$ = ""

do
NumberMoves = NumberMoves + 1:DT=0
if actionpict$<>"" then showaction else showpic P
m$=""
IF P = MessagePlace AND Flags(KNOWPASS1) = 0 THEN m$ = "MESSAGE FOR YOU HERE"

Flags(FRIENDNEAR3) = 0
intime=(tim>=MeetingTime AND tim<=MeetingTime+15)
IF Flags(FRIENDWAIT4) = 1 AND Room$(P) = MeetingPlaceName$ AND intime THEN
    m$="CONTACT IS HERE": Flags(FRIENDNEAR3) = 1
END IF

IF EnemyPlace = P THEN
  EnemyNear=EnemyNear+1
  ' If player action="Follow"...
  if Verb=6 and EnemyNear>1 then EnemyNear=1
  m$ = "ENEMY AGENT IS HERE"+string$(EnemyNear,"!")
  darkscreen
else 
  EnemyNear = 0
  if B$ = "ENEMY AGENT SEES YOU!" then B$=""
  if B$ = "YOU KEPT HIM IN SIGHT" then B$=""
end if

'IF EnemyNear >= 3 and B$="" THEN B$ = "ENEMY AGENT SEES YOU!"
'IF EnemyNear >= 5 THEN B$ = "YOU ARE CAPTURED!":FlagCaptured=1

showclock tim
say2 1+29,"YOU ARE AT "+Room$(p)
say2 1+30,m$
say2 1+31,B$
say2 1+32,"WHAT NEXT"
B$ = ""
xINPUT 1+33,a$
xCLS
Verb = 0
FOR I = 1 TO MAXVERB
IF a$ = action$(I) THEN Verb = I
NEXT I
IF Verb = 0 THEN Verb = MAXVERB+1

SELECT CASE Verb
    CASE 1: AMOVE
    CASE 2: ASAY
    CASE 3: AEXAMINE
    CASE 4: AREAD
    CASE 5: AOPEN
    CASE 6: AFOLLOW
    CASE 7: AWAIT
    CASE 8: ALEAVE
    CASE 9: ASEARCH
    CASE 10: ADEBUG
    CASE 11: AHELP:waitkey
    CASE 12: GOTO gamestart
    CASE 13: AQUIT
    CASE ELSE: AINVALID
END SELECT

tim=tim+DT:DT=0
if tim>=fh*60 then GameLooseSub:gameloose=1
IF EnemyPlace <> P THEN EnemyNear=0
IF EnemyNear >= 3 and B$="" THEN B$ = "ENEMY AGENT SEES YOU!"
IF EnemyNear >= 5 THEN GameLooseSub2:gameloose=2
if flags(HAVECASE6) and flags(MISSIONEND7) and P=ind("STATION") then
    GameWinSub:WinAniPlay:gamewin=1
end if
IF Flags(MESSAGELEFT2) = 1 AND tim >= CH*60 THEN Flags(FRIENDWAIT4) = 1
IF RAND(10) > 8 THEN EnemyPlace = ind("HOTEL")
loop while gamewin=0 and gameloose=0

do
if actionpict$<>"" then showaction else showpic P
if gameloose=2 then darkscreen
m$=""
showclock tim
say2 1+29,"YOU ARE AT "+Room$(p)
say2 1+30,m$
say2 1+31,B$
say2 1+32,"WHAT NEXT: RESTART OR QUIT?"
B$ = ""
xINPUT 1+33,a$
xCLS
Verb = 0
FOR I = 1 TO MAXVERB
IF a$ = action$(I) THEN Verb = I
NEXT I
IF Verb = 0 THEN Verb = MAXVERB+1
SELECT CASE Verb
case 12:goto gamestart
case 13:AQUIT
case else:ainvalid
end select
loop while 1

end

DACTION:
     DATA "MOVE","SAY","EXAMINE","READ","OPEN","FOLLOW","WAIT","LEAVE","SEARCH"
     DATA "DEBUG","HELP","RESTART","QUIT"
DPASS:
     DATA "CUSTARD","KIPPER","KOALA","CRUMPET","CROSSWORD","KANGAROO"

sub jpginit()
ijlib=DYLIBLOAD(exep$+"IJL10.DLL")
' add error check
if ijlib=0 then print "IJL10.DLL not found":sleep:end
ijlInit=dylibsymbol(ijlib,"ijlInit")
ijlFree=dylibsymbol(ijlib,"ijlFree")
ijlRead=dylibsymbol(ijlib,"ijlRead")
ijlWrite=dylibsymbol(ijlib,"ijlWrite")
ijlGetLibVersion=dylibsymbol(ijlib,"ijlGetLibVersion")
ijlErrorStr=dylibsymbol(ijlib,"ijlErrorStr")
end sub

'Load JPG file jname$ to memory bitmap using Ijl10.dll
function jpgload(jname$) as long
jerr = ijlInit(jcprops)
if jerr<>0 then jpgload=jerr:exit function
fname=jname$
jcprops.JPGFile = cast(long,StrPtr(fname))
' read jpg header only
jerr = ijlRead(jcprops, IJL_JFILE_READPARAMS) ' add "... RAMS or 1" to read from memory
imgw = jcprops.JPGWidth
imgh = jcprops.JPGHeight
' create output image buffer
if jpgout=0 then jpgout=imagecreate(imgw,imgh,0)
jcprops.JPGColor = IJL_YCBCR
jcprops.DIBColor = IJL_RGBA_FPX
jcprops.DIBWidth = imgw
jcprops.DIBHeight = imgh
jcprops.DIBChannels = 4
jcprops.DIBBytes=cast(long,jpgout+1)
jcprops.DIBPadBytes = IJL_DIB_PAD_BYTES(jcprops.DIBWidth, jcprops.DIBChannels)
jerr = ijlRead(jcprops, IJL_JFILE_READWHOLEIMAGE) ' add "... RAMS or 1" to read from memory
swaprgb()
jerr = ijlFree(jcprops)
'we PUT data on screen in showpic sub so next PUT is excluded
'put(0,0),jpgout,pset
jpgload=0    
end function

'Need to swap red and blue bytes in picture data
sub swaprgb()
n=jcprops.JPGWidth * jcprops.JPGHeight
for i=1 to n
    d=*(jpgout+i)
    r=d and 255
    g=(d shr 8) and 255
    b=(d shr 16) and 255
    'r=r*2:if r>255 then r=255
    *(jpgout+i)=rgb(r,g,b)
'    gray=(r+g+b)/3
'    *(jpgout+i)=rgb(gray,gray,gray)
NEXT i    
end sub

sub darkscreen
n=640*480
for i=1 to n
    d=*(jpgout+i)
    b=d and 255
    g=(d shr 8) and 255
    r=(d shr 16) and 255
    *(jpgout+i)=rgb(r/2,g/2,b)
NEXT i
apage 1:put(0,0),jpgout,pset
apage 0:put(0,0),jpgout,pset
end sub

sub GameLooseSub
P=ind("STATION")
B$="GAME OVER,YOU MISSED THE LAST TRAIN!"
GameLoose=1
end sub

sub GameLooseSub2
P=ind("HOTEL")
B$="GAME OVER,YOU CAPTURED BY ENEMY!"
GameLoose=2
end sub



SUB GameWinSub
ti=tim-tim0
ho=int(ti / 60)
mi=ti-ho*60
ho=ho mod 24
text$=right$(str$(100+ho),2)+":"+right$(str$(100+mi),2)
xCLS:y0=3
xprint ""
xprint "CONGRATULATIONS"
xprint "==============="
xprint "YOU WIN THIS GAME USING "+STR$(NumberMoves)+" MOVES"
xprint "YOU SPENT "+text$+" OF GAME TIME"
xprint "YOU HAVE OPENED "+STR$(OpenMax)+" PICTURES"
xprint ""
xprint "PRESS ENTER TO CONTINUE"
xprint ""
waitkey
P=ind("STATION")
B$="CONGRATULATIONS, YOU WIN THE GAME!"
GameWin=1
END SUB

sub gameintro
open exep$+"data\map.txt" for input as #1
for i=1 to MAXROOM
line input #1,room$(i)
input #1,rr$
if rr$="nofile" then
    roompic$(i)=rr$
else
    roompic$(i)="data\"+rr$+"\"+rr$
end if
NEXT i
close #1
open exep$+"data\action.txt" for input as #1
i=0
while not eof(1)
i=i+1
input #1,acti$(i):input #1,rr$:input #1,actcnt(i)
if rr$="nofile" then
    actpic$(i)=rr$
else
    actpic$(i)="data\"+rr$+"\"+rr$
end if
wend
close #1
actmax=i
restore daction
FOR I = 1 TO MAXVERB: READ action$(I): NEXT I
H = RAND(2) + 8: M = 0
tim=h*60+m:tim0=tim
FH = RAND(2) + 14
CH = RAND(2) + H
EnemyNear = 0
MessagePlace = RAND(MAXROOM): KeyPlace = RAND(MAXROOM)
EnemyPlace = RAND(MAXROOM): CP = RAND(MAXROOM)
FOR I = 1 TO 7: flags(I) = 0: NEXT I
OpenMax=0:for i=1 to 100:openpic$(i)="":NEXT i
restore dpass
FOR I = 1 TO RAND(MAXPWD)
READ Password$: NEXT I
NumberLock = RAND(900) + 99
gamewin=0:gameloose=0
end sub

'Count different pictures loaded
sub addpic(N$)
for i=1 to OpenMax
    if N$=openpic$(i) then exit sub
NEXT i
OpenMax=OpenMax+1
openpic$(i)=N$
end sub

SUB HELPGAME
y0=4
xPRINT ""
xPRINT "RENDEZVOUS"
xPRINT "=========="
xPRINT ""
xPRINT "COLLECT MESSAGE FROM"
xPRINT "THE "+Room$(MessagePlace)
xPRINT "CONTACT WILL COLLECT"
xPRINT "FROM THE "+Room$(CP)
xPRINT "AT "+str$(CH)+":00"
xPRINT ""
HELPTRAIN
END SUB

SUB help2
open exep$+"data\help.txt" for input as #1
transpar=0
retry:
line(0,0)-(639,479),rgb(0,0,255),BF
y0=2
do
    line input #1,n$
    if n$="END" then exit do
    if n$="*" then waitkey:goto retry
    xPrint n$
loop while not eof(1)
close #1
transpar=1
END SUB


SUB AHELP
    DT = 5
    y0=4
    xPRINT ""
    IF MeetingTime <> 0 THEN
      ho=int(MeetingTime / 60)
      mi=MeetingTime-ho*60
      ho=ho mod 24
      text$=right$(str$(100+ho),2)+":"+right$(str$(100+mi),2)
      xPRINT "MEETING PLACE IS"
      xPRINT MeetingPlaceName$+" AT "+text$
    END IF
    HELPTRAIN
END SUB

SUB HELPTRAIN
     xPRINT "LAST TRAIN LEAVES"
     xPRINT "AT "+str$(FH)+".00"
     L$="":FOR I = 1 TO 7:L$=L$+str$(Flags(I)) : NEXT I
     if debugflag then xPRINT "F()="+L$
     if debugflag then xPRINT "KEY="+Room$(KeyPlace)
     xPRINT "OPENED PICURES - "+STR$(OpenMax)
     xPRINT "PRESS RETURN TO CONTINUE"
     xPRINT ""
END SUB



function showpic(n as long)
rr$=roompic$(n)
if rr$="nofile" then
    for i=0 to 1:apage i:cls 1:locate 1,1:print "no picture";n:NEXT i
    wtflag=0
else
    if jpgout=0 then jpgout=imagecreate(640,480,0)
    if wtflag=0 then
        cod$="1"
    else
        cod$=chr$(49+rand(2))
        wtflag=0
    end if
    'bload rr$+cod$+".bmp",jpgout
    addpic  rr$+cod$+".jpg"
    jpgLoad exep$+rr$+cod$+".jpg"
    for i=0 to 1:apage i
    put (0,0),jpgout,pset
    'debug - print location number
    'if i=0 then locate 1,1:print n
    NEXT i
end if
showpic=0
end function

function showaction
rr$="nofile"
for i=1 to actmax
if actionpict$=acti$(i) then
  rr$=actpic$(i):c=actcnt(i)
end if
NEXT i
if rr$="nofile" then
    for i=0 to 1:apage i:cls 1:locate 1,1:print "no picture":NEXT i
    actionpict$=""
else
    if jpgout=0 then jpgout=imagecreate(640,480,0)
    cod$=chr$(48+rand(c))
    actionpict$=""
    'bload rr$+cod$+".bmp",jpgout
    addpic  rr$+cod$+".jpg"
    jpgLoad exep$+rr$+cod$+".jpg"
    for i=0 to 1:apage i
    put (0,0),jpgout,pset
    NEXT i
end if
showaction=0
end function


SUB Apage (N)
screenset N,0
END SUB

SUB LoadRus
open exep$+"data\ansi2866.set" for binary as #1
get #1,,win2dos(1),255
close #1
Apage 3
open exep$+"data\egarus.bmp" for binary as #1
seek #1,&h3F
for j=14*16-1 to 0 step -1
for i=0 to 15
    get #1,,a1:d=asc(a1):m=128
    for k=0 to 7
        if (d and m)>0 then col=rgb(255,255,255) else col=rgb(0,0,255)
        line(16*i+2*k,j)-step(1,0),col
        m=m/2
    NEXT k
NEXT i
NEXT j
close #1
Apage 0
end SUB

' Print line of text in line y
' This tricky SUB use a font with russian letters
' preloaded to page 2
SUB say2 (y,txt$)
if len(txt$)>40 then text$=mid$(txt$,1,40) else text$=txt$+space$(40-len(txt$))
' Display string
yto=(y-1)*14:xto=0
for i=1 to len(text$)
cod=win2dos(asc(MID$(text$,i,1)))
xf=16*INT(cod/16):yf=14*(cod mod 16)
Apage 3:GET(xf,yf)-step(15,13),grafbuf
Apage 2:PUT(xto,yto),grafbuf,pset
xto=xto+16
NEXT i
' Color string
Apage 1

yto=(y-1)*14:xto=0
get(xto,yto)-step(639,13),grafbuf
Apage 0
PUT(xto,yto),grafbuf,pset

apage 2
get(xto,yto)-step(639,13),grafbuf
Apage 0

'Make transparency channel
n=640*14
for i=1 to n
    d=grafbuf(i):if (d and &h00FF00)<>0 then 
        ' letter - color white, solid
        grafbuf(i)=rgba(255,255,255,255)
    else
        ' background - color blue with alpha 96
        grafbuf(i)=rgba(0,0,255,96)
    end if
next i

if transpar then
    PUT(xto,yto),grafbuf,alpha:',128
else
    PUT(xto,yto),grafbuf,pset
end if
END SUB

sub xPRINT(txt$)
say2 y0,space$(1)+txt$
y0=y0+1
end sub

FUNCTION xINKEY$
' The same as INKEY$ but check a mouse click on window
q$=inkey$
IF q$ = CHR$(255) + CHR$(107) THEN END' Exit on window cross
xINKEY$=q$    
END FUNCTION

sub xCLS
for i=3 to 34
  Apage 1
  yto=(i-1)*14:xto=0
  get(xto,yto)-step(639,13),grafbuf
  Apage 0
  PUT(xto,yto),grafbuf,pset
NEXT i
end sub

SUB xINPUT (y,M$)
' Input player text and animate a beast at the same time
'
'  Input text=""
te$ = ""
' Run a cycle until the ENTER key is pressed (code 13)
DO
' Display string
say2 y,">"+te$+"_"
' Expect a keystroke.
DO: i$ = xINKEY$: mousecheck : SLEEP 50: LOOP WHILE i$ = ""
' Keys that do not match the ASCII code are ignored
IF LEN(i$) = 1 THEN
' If the BACKSPACE key (code 8) is pressed,
' the last character is deleted
IF ASC(i$) = 8 AND LEN(te$) > 0 THEN te$ = MID$(te$, 1, LEN(te$) - 1)
' If a symbol key is pressed,
' then the character is added to the input line
IF ASC(i$) >= 32 AND  LEN(te$) < 38 THEN te$ = te$ + ucase$(i$)
END IF
LOOP WHILE ASC(i$) <> 13
' The procedure returns the entered string
M$ = trim$(te$)
END SUB

sub waitkey
DO: i$ = xINKEY$: mousecheck : SLEEP 50: LOOP WHILE i$ <> chr$(13)
DO: i$ = xINKEY$: SLEEP 50: LOOP WHILE i$ <> ""
end sub

'Show clear picture (page 1) on right mouse button press
sub mousecheck
getmouse mx,my,,mb
if mb<>2 then exit sub
screenset 1,1
do
    SLEEP 50
    getmouse mx,my,,mb
loop while mb=2
screenset 0,0
end sub

SUB ADEBUG
    DT=0:debugflag=not debugflag
    if debugflag then b$="DEBUG IS ON" else b$="DEBUG IS OFF"
END SUB

SUB AINVALID
    DT = 0: B$ = "PARDON?"
END SUB

SUB AQUIT
say2 31,""
say2 32,"QUIT GAME (Y/N)?"
'say2 33,">"
say2 34,""
xINPUT 33,a$
if mid$(a$,1,1)="Y" then end
END SUB

SUB AWAIT
say2 31,""
say2 32,"HOW MANY MINUTES"
'say2 33,">"
say2 34,""
xINPUT 33,a$
i=val(a$)
if i<5 then i=5
if i>60 then i=60
DT=i:wtflag=1
END SUB

SUB ALEAVE
    if Flags(MESSAGELEFT2) = 1 then b$="YOU HAVE ALREADY LEFT A MESSAGE":EXIT SUB
    IF P<>CP then b$="FIRST GO TO THE "+Room$(CP):exit sub
    ' end of game in progress
    if tim >= CH*60 then b$="TOO LATE: YOU FRIEND HAS GONE":exit sub
    actionpict$="LEAVE"
retry1:
    say2 31,""
    say2 32,"WHERE DO YOU WHANT TO MEET"
    say2 34,""
    xINPUT 33,MeetingPlaceName$
    fnd=0
    for i=1 to 20
        if MeetingPlaceName$=Room$(i) then fnd=i
    NEXT i
    if fnd=0 then goto retry1
retry2:    
    say2 32,"WHAT TIME [HH.MM]"
    xinput 33,utext$
    j=instr(utext$,".")
    if j = 0 then goto retry2
    ho=val(mid$(utext$,1,j-1))
    mi=val(mid$(utext$,j+1))
    if ho>23 or ho<0 or mi>59 or mi<0 then goto retry2
    MeetingTime=ho*60+mi
    if MeetingTime<tim then MeetingTime=0:b$="LOOK AT THE GAME WATCH!":dt=5:exit sub
    text$=right$(str$(100+ho),2)+":"+right$(str$(100+mi),2)
    B$="MEET AT THE "+MeetingPlaceName$+" AT "+text$
    Flags(MESSAGELEFT2) = 1
    DT = 5
END SUB

SUB ASAY
    DT = 5
    if flags(FRIENDNEAR3)=1 and Flags(HAVECASE6) = 1 and Flags(MISSIONEND7) = 1 then
        B$="NOW HURRY TO THE RAILWAY STATION!":exit sub
    end if
    say2 31,""
    say2 32,"SAY WHAT"
    say2 34,""
    xINPUT 33,Phrase$
    IF EnemyPlace = P THEN 
        B$ = "YOU ATTRACTED THE ENEMY AGENT!"
        if EnemyNear<3 then EnemyNear=3
        EXIT SUB
    END IF
    IF Flags(FRIENDNEAR3) = 0 THEN B$ = "NOBODY HEARS YOU": EXIT SUB
    actionpict$="SAY"
    IF Phrase$ <> Password$ THEN B$ = "CONTACT IGNORES YOU!": EXIT SUB
    
    IF Flags(HAVECASE6) = 1 THEN
        B$ = "YOU MADE CONTACT - HE TAKES THE CASE!"
        Flags(MISSIONEND7) = 1
    ELSE
        B$ = "YOU FAILED TO FIND THE CASE"
    END IF
END SUB

SUB AFOLLOW
    DT = 5
    IF EnemyPlace <> P THEN B$ = "FOLLOW WHO?": EXIT SUB
    NP = RAND(20): DOMOVE: P = NP
    IF RAND(10) > 7 THEN P = KeyPlace
    IF RAND(10) > 5 THEN B$ = "YOU LOST HIM AFTER A WHILE!": EXIT SUB
    EnemyPlace = P
    B$ = "YOU KEPT HIM IN SIGHT"
END SUB


SUB AREAD
    actionpict$="READ"
    IF P <> MessagePlace OR Flags(KNOWPASS1) = 1 THEN B$ = "NOTHING TO READ!": EXIT SUB
    B$ = "A WORD -'" + Password$ + "'"
    Flags(KNOWPASS1) = 1
END SUB


SUB AEXAMINE
    DT = 5
    if flags(MISSIONEND7)<>0 THEN b$="YOU HAVE ALREADY GIVEN THE CASE":EXIT SUB
    if flags(HAVECASE6)<>0 THEN b$="THE CASE CONTAINS TOP SECRET PAPERS!":EXIT SUB
    IF flags(HAVEKEY5)<>0 THEN B$ = "A NUMBER ON KEY - " + STR$(NumberLock): EXIT SUB
    B$ = "YOU MUST FIND A KEY FIRST"
END SUB

SUB AOPEN
    DT = 5
    if Flags(HAVECASE6) = 1 then B$ = "NOW YOU MUST MEET YOUR FRIEND AGENT!":EXIT SUB
    IF P <> ind("PORT") THEN B$ = "FIRST FIND A CHEST TO OPEN!": EXIT SUB
    IF Flags(HAVEKEY5) = 0 THEN B$ = "YOU HAVE NO KEY": EXIT SUB
    say2 31,""
    say2 32,"WHAT IS THE CODE ON KEY?"
    'say2 33,">"
    say2 34,""
    xINPUT 33,N$:YN=VAL(N$)
    IF NumberLock <> YN THEN B$ = "YOU CAN NOT TURN THE KEY": EXIT SUB
    actionpict$="OPEN"
    B$ = "THE LOCK IS OPENED, YOU HAVE THE CASE!": Flags(HAVECASE6) = 1
END SUB


SUB ASEARCH
    actionpict$="SEARCH"
    B$ = "NOTHING HERE": DT = 10
    if Flags(HAVEKEY5) = 1 then exit sub
    IF P = KeyPlace THEN B$ = "YOU FOUND A KEY": Flags(HAVEKEY5) = 1
END SUB

SUB AMOVE
RETRY:
say2 31,""
say2 32,"WHERE TO:"
'say2 33,">"
say2 34,""
xINPUT 33,N$
NP = 0
FOR I = 1 TO MAXROOM
IF N$ = Room$(I) THEN NP = I
NEXT I
IF NP = 0 THEN
    xCLS
    y0=3
    for i=1 to MAXROOM:xPrint Room$(i):NEXT i
    GOTO RETRY
END IF
DOMOVE
P = NP
END SUB

SUB DOMOVE
    NY = INT((NP - 1) / 5)
    NX = NP - 5 * NY
    DX = ABS(playerX - NX): DY = ABS(playerY - NY)
    playerX = NX: playerY = NY
    D = SQR(DX ^ 2 + DY ^ 2)
    DT = INT(5 * D)
END SUB

sub showclock(gametime)
ho=int(gametime / 60)
mi=gametime-ho*60
ho=ho mod 24
text$=right$(str$(100+ho),2)+":"+right$(str$(100+mi),2)
' Display string
yto=4:xto=4
for i=1 to len(text$)
cod=win2dos(asc(MID$(text$,i,1)))
xf=16*INT(cod/16):yf=14*(cod mod 16)
Apage 3:GET(xf,yf)-step(15,13),grafbuf
Apage 2:PUT(xto,yto),grafbuf,pset
xto=xto+16
NEXT i
apage 2
for i=1 to 4
line (4-i,4-i)-step(79+i+i,13+i+i),rgb(0,0,255),B
NEXT i
get(0,0)-step(79+8,13+8),grafbuf2

n=88*22
for i=1 to n
    d=grafbuf2(i):if (d and &h00FF00)<>0 then 
        grafbuf2(i)=rgba(255,255,255,255)
    else
        grafbuf2(i)=rgba(0,0,255,96)
    end if
next i

' Color string
Apage 1

yto=4:xto=639-84-8
get(xto,yto)-step(79,13),grafbuf

Apage 0
PUT(xto,yto),grafbuf,pset
PUT(xto,yto),grafbuf2,alpha:',128
end sub

FUNCTION RAND (X)
RAND = INT(RND(1) * X) + 1
END FUNCTION

function ind(N$)
for i=1 to MAXROOM
if N$=Room$(i) then ind=i:exit function
NEXT i
? "Error: Room$ index not found -";N$:SLEEP:end
ind=0
end function

'win animation code

sub WinAniLoad
jpgLoad exep$+"data\!win\!win1.jpg"
if winbg1=0 then winbg1=ImageCreate(640,480)
put winbg1,(0,0),jpgout,pset

jpgLoad exep$+"data\!win\!win2.jpg"
if winbg2=0 then winbg2=ImageCreate(640,480)
put winbg2,(0,0),jpgout,pset

jpgLoad exep$+"data\!win\fly.jpg"
makeanim
end sub

sub WinAniPlay
dim k as single,fi as single,fi0 as single,rad as single
k=3.1416/180
cnt=0:cnt2=0:a=0:fi0=0
rad=160:dr=1
while 1
if cnt=0 then a=not a
if a=0 then put(0,0),winbg1,pset else put(0,0),winbg2,pset
fi0=(fi0+2) mod 360
for n=0 to 11
fi=k*(n*40+fi0)
x=260+rad*cos(fi)
y=240+0.6*rad*sin(fi)
get anim,(64*((cnt2+3*n) mod 14),0)-step(63,63),spt
put (x,y),spt,alpha
next n
if rad<=160 then dr=1
if rad>=440 then dr=-1
rad=rad+4*dr
cnt=(cnt+1) mod 5
cnt2=(cnt2+1) mod 15
sleep 100
if xinkey$<>"" then
    while xinkey$<>"":sleep 50:wend
    exit sub
end if
wend
end sub

'make animation image with alpha channel
sub makeanim
if anim=0 then anim=imagecreate(960,64)
n=0
for j=0 to 2:for i=0 to 4
    xf=128*i:yf=64*j
    xt=64*n:yt=0
    for v=0 to 63:for u=0 to 63
        ' pixel of image
        d=point(xf+u,yf+v,jpgout)
        b=d and 255
        g=(d shr 8) and 255
        r=(d shr 16) and 255
        ' pixel of mask
        d=point(xf+u+64,yf+v,jpgout)
        a=d and 255
        pset anim,(xt+u,yt+v),rgba(r,g,b,a)
    next u:next v
    n=n+1
next i:next j
end sub

